var  _ = require("underscore"),
    fs = require("fs.extra"), 
  uuid = require('node-uuid');

function ImageStore(baseDir) {
    if (!fs.existsSync(baseDir)) {
        fs.mkdirpSync(baseDir);
    }

    this._storeRoot = baseDir;
}

ImageStore.prototype.store = function(path, callback) {
    var id = uuid.v1();

    var extension = path.substring(path.lastIndexOf('.') + 1, path.length);

    var newPath = this._storeRoot + '/' + id + '.' + extension;

    fs.move(path, newPath, function(err) {
        if (err) {
            callback(err);
            return;
        }

        callback(null, newPath);
    })

};



module.exports = {
    ImageStore:ImageStore
};