var util = require('util'), 
       _ = require('underscore');

var Arrays = {

  clone: function(array) {
    if (!util.isArray(array)) {
      return null;
    }
    
    return array.slice();
  }

};

const NO_ERROR = undefined;

// conversion Functions
function _callbacksToCallback(callbacks) {
  return function(err) {
      if (err) {
        callbacks.error(err);
        return;
      }

      callbacks.success.apply(undefined, _.tail(_.toArray(arguments)));
  }
}

function _callbackToCallbacks(callback) {
    return {
      success: function() {
        var args = [NO_ERROR].concat(_.toArray(arguments));
        callback.apply(null, args);
      },
      error: function(err) {
        callback(err);
      }
    }
}


var Callbacks = {
  toStandardCallback: _callbacksToCallback,
  toObjectCallbacks: _callbackToCallbacks
};


//
// Exports
module.exports = {
   Arrays: Arrays,
   Callbacks: Callbacks
};