var vows = require('vows'),
    assert = require('assert'),
    fs = require('fs.extra'),
    ImageStore = require('../lib/imagestore').ImageStore;

vows.describe("ImageStore").addBatch({
    
    "An ImageStore": {

        topic: function() {
            var self = this;
            fs.copy('./testdata/2000px-SMPTE_Color_Bars.png', '/tmp/test.png', function(err) {
                if(err) {  
                    console.error(err);
                    // return;
                }
                // ignore the error, most likely, it's due to the file already being there.
                self.callback(null, new ImageStore('/tmp/lattices-photostore' + new Date().getTime()))
            }); 
        }, 

        teardown: function(imageStore) {
            fs.rmrfSync(imageStore._storeRoot);
        },

        "should move a file into the store" : {
            topic: function (imageStore) {
                imageStore.store('/tmp/test.png', this.callback);
            },

            "with an unique name": function (newPath) {
                assert.equal(newPath.indexOf('/tmp/lattices-photostore'), 0);
                assert.isTrue(fs.existsSync(newPath));
                assert.isFalse(fs.existsSync('/tmp/test.png'))
            }
        } 


    }
}).export(module);